package interpreter;

public class InteractiveLispInterpreter extends LispInterpreter {

    private static final String GREETING = "Transcendental Lisp - Version 1.0.0";
    private static final String PROMPT = "~ ";

    @Override
    protected void beforeInterpreting() {
        environment.getOutput().println(GREETING);
        environment.getOutput().println();
        environment.getOutput().flush();
    }

    @Override
    protected void prompt() {
        environment.getOutput().print(environment.decorateOutput(PROMPT));
        environment.getOutput().flush();
    }

    @Override
    protected void printValueOfNextSExpression() {
        environment.getOutput().println();
        super.printValueOfNextSExpression();
    }

    @Override
    protected void afterInterpreting() {
        environment.getOutput().println();
        environment.getOutput().println();
        environment.getOutput().close();
    }

}
